# github-reaction-button

Reaction button that stores reaction data in github issues.

## Demo
[https://yusukeshibata.github.io/github-reaction-button/](https://yusukeshibata.github.io/github-reaction-button/)

## Usage-1

```html
<script src="https://unpkg.com/github-reaction-button/dist/githubreactionbutton.js"></script>
```

```html
  <p class='entry'>
    Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry's standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book. It has survived not only five centuries, but also the leap into electronic typesetting, remaining essentially unchanged. It was popularised in the 1960s with the release of Letraset sheets containing Lorem Ipsum passages, and more recently with desktop publishing software like Aldus PageMaker including versions of Lorem Ipsum. <br>
    <span id="demo"></span>
  </p>
  <script>
    var reaction = new GithubReactionButton({
      client_id: '46820c8d83fd9dc45a06',
      client_secret: 'c96443bd3a31e4fac81bdea5d924740b8fcb4a87',
      repo: 'github-reaction-button',
      owner: 'yusukeshibata',
      issue: 1,
      id: 'test-1'
    })
    reaction.render('demo')
</script>
```
![screenshot](screenshot.gif?raw=true)

## Usage-2

```sh
npm install github-reaction-button
```

```js
import Reaction from 'github-reaction-button'

const reaction = new Reaction({
  client_id: '1f9904a67c7fc618cd4f',
  client_secret: '74705a6d0b05818882e20d72af21ab56dbc80658',

  repo: 'github-reaction-button',
  owner: 'yusukeshibata',
  issue: 1,

  id: 'test-1',

  // optional
  redirect_uri: 'https://yusukeshibata.github.io/github-reaction-button/',
})
reaction.render('demo')
```

### Easily embed multiple buttons

```js
import Reaction from 'github-reaction-button'

const reaction = new Reaction({
  client_id: '1f9904a67c7fc618cd4f',
  client_secret: '74705a6d0b05818882e20d72af21ab56dbc80658',
  repo: 'github-reaction-button',
  owner: 'yusukeshibata',
  issue: 1
})

// render to #demo
reaction.render('demo', {
  id: 'test-1'
})

// render to #demo2
reaction.render('demo2', {
  id: 'test-2'
})
```


### TODO

* [x] Custom renderer
* [ ] Test code
* [ ] Adding comment
* [ ] Reduce bundle size by preact
