'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _utils = require('./utils');

var _store = require('./store');

var _store2 = _interopRequireDefault(_store);

var _qs = require('./qs');

var _concurrentLock = require('concurrent-lock');

var _concurrentLock2 = _interopRequireDefault(_concurrentLock);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var lock = new _concurrentLock2.default();

var GithubLogin = function () {
  function GithubLogin() {
    _classCallCheck(this, GithubLogin);
  }

  _createClass(GithubLogin, [{
    key: 'fetchCode',
    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var _props, redirect_uri, client_id;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _props = this.props, redirect_uri = _props.redirect_uri, client_id = _props.client_id;
                // store redirect_uri

                _context.next = 3;
                return _store2.default.set('redirect_uri', location.href.split('?')[0]);

              case 3:
                _context.t0 = _qs.stringify;
                _context.t1 = client_id;
                _context.t2 = redirect_uri;

                if (_context.t2) {
                  _context.next = 10;
                  break;
                }

                _context.next = 9;
                return _store2.default.get('redirect_uri');

              case 9:
                _context.t2 = _context.sent;

              case 10:
                _context.t3 = _context.t2;
                _context.t4 = {
                  client_id: _context.t1,
                  redirect_uri: _context.t3,
                  scope: 'public_repo'
                };
                _context.t5 = (0, _context.t0)(_context.t4);
                location.href = 'https://github.com/login/oauth/authorize?' + _context.t5;

              case 14:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function fetchCode() {
        return _ref.apply(this, arguments);
      }

      return fetchCode;
    }()
  }, {
    key: 'init',
    value: function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(props) {
        var q, ret, access_token, username, redirect_uri;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return lock.lock();

              case 2:
                this.props = props;
                q = (0, _qs.parse)(location.search);
                ret = false;

                if (!q.code) {
                  _context2.next = 26;
                  break;
                }

                if (!this.props.id) {
                  _context2.next = 19;
                  break;
                }

                history.replaceState(null, null, location.href.split('?')[0]);
                _context2.next = 10;
                return this.fetchAccessToken(q.code);

              case 10:
                access_token = _context2.sent;
                _context2.next = 13;
                return this.fetchUsername(access_token);

              case 13:
                username = _context2.sent;
                _context2.next = 16;
                return _store2.default.set({ username: username, access_token: access_token });

              case 16:
                ret = true;
                _context2.next = 26;
                break;

              case 19:
                _context2.next = 21;
                return _store2.default.get('redirect_uri');

              case 21:
                redirect_uri = _context2.sent;

                if (!(redirect_uri && redirect_uri !== location.href)) {
                  _context2.next = 26;
                  break;
                }

                _context2.next = 25;
                return _store2.default.remove('redirect_uri');

              case 25:
                location.href = redirect_uri + '?code=' + q.code;

              case 26:
                lock.unlock();
                return _context2.abrupt('return', ret);

              case 28:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function init(_x) {
        return _ref2.apply(this, arguments);
      }

      return init;
    }()
  }, {
    key: 'fetchAccessToken',
    value: function () {
      var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(code) {
        var _props2, client_id, client_secret, q, _ref4, access_token;

        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _props2 = this.props, client_id = _props2.client_id, client_secret = _props2.client_secret;
                q = (0, _qs.stringify)({
                  client_id: client_id,
                  client_secret: client_secret,
                  code: code
                });
                _context3.next = 4;
                return (0, _axios2.default)({
                  url: 'https://cors-anywhere.herokuapp.com/https://github.com/login/oauth/access_token?' + q,
                  method: 'get',
                  headers: { 'Accept': 'application/json' }
                });

              case 4:
                _ref4 = _context3.sent;
                access_token = _ref4.data.access_token;
                return _context3.abrupt('return', access_token);

              case 7:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function fetchAccessToken(_x2) {
        return _ref3.apply(this, arguments);
      }

      return fetchAccessToken;
    }()
  }, {
    key: 'fetchUsername',
    value: function () {
      var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(access_token) {
        var _ref6, login;

        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return (0, _axios2.default)({
                  url: 'https://api.github.com/user',
                  method: 'get',
                  headers: {
                    'Authorization': 'token ' + access_token
                  }
                });

              case 2:
                _ref6 = _context4.sent;
                login = _ref6.data.login;
                return _context4.abrupt('return', login);

              case 5:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function fetchUsername(_x3) {
        return _ref5.apply(this, arguments);
      }

      return fetchUsername;
    }()
  }, {
    key: 'login',
    value: function login() {
      this.fetchCode();
    }
  }]);

  return GithubLogin;
}();

exports.default = new GithubLogin();