'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _utils = require('./utils');

var _find = require('lodash/find');

var _find2 = _interopRequireDefault(_find);

var _store = require('./store');

var _store2 = _interopRequireDefault(_store);

var _renderer = require('./renderer');

var _renderer2 = _interopRequireDefault(_renderer);

var _GithubLogin = require('./GithubLogin');

var _GithubLogin2 = _interopRequireDefault(_GithubLogin);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Reaction = function (_Component) {
  _inherits(Reaction, _Component);

  function Reaction(props) {
    _classCallCheck(this, Reaction);

    var _this = _possibleConstructorReturn(this, (Reaction.__proto__ || Object.getPrototypeOf(Reaction)).call(this, props));

    _this.state = {
      reacted: false,
      busy: false,
      count: 0
    };
    _this.onReact = _this.onReact.bind(_this);
    return _this;
  }

  _createClass(Reaction, [{
    key: 'componentDidMount',
    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var _props, id, client_id, client_secret, owner, repo, issue, loggedIn, count, reaction;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                this._mounted = true;
                _props = this.props, id = _props.id, client_id = _props.client_id, client_secret = _props.client_secret, owner = _props.owner, repo = _props.repo, issue = _props.issue;


                this.setState({ busy: true });

                _context.next = 5;
                return _GithubLogin2.default.init(this.props);

              case 5:
                loggedIn = _context.sent;

                if (!this.id) {
                  _context.next = 20;
                  break;
                }

                _context.prev = 7;
                _context.next = 10;
                return this.fetchReactionCount();

              case 10:
                count = _context.sent;
                _context.next = 13;
                return this.fetchViewersReaction();

              case 13:
                reaction = _context.sent;

                if (this._mounted) {
                  this.setState({
                    reaction: reaction,
                    count: count
                  });
                }

                _context.next = 20;
                break;

              case 17:
                _context.prev = 17;
                _context.t0 = _context['catch'](7);

                console.warn(_context.t0);

              case 20:

                if (this._mounted) {
                  this.setState({ busy: false });
                }

                if (loggedIn) {
                  this.onReact();
                }

              case 22:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[7, 17]]);
      }));

      function componentDidMount() {
        return _ref.apply(this, arguments);
      }

      return componentDidMount;
    }()
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this._mounted = false;
    }
  }, {
    key: 'fetchReactionCount',
    value: function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
        var _props2, client_id, client_secret, owner, repo, issue, _ref3, total_count;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _props2 = this.props, client_id = _props2.client_id, client_secret = _props2.client_secret, owner = _props2.owner, repo = _props2.repo, issue = _props2.issue;
                _context2.next = 3;
                return (0, _axios2.default)({
                  url: 'https://api.github.com/search/issues',
                  method: 'get',
                  params: {
                    client_id: client_id,
                    client_secret: client_secret,
                    q: 'repo:' + owner + '/' + repo + ' ' + this.key + ' in:comments',
                    t: Date.now()
                  },
                  headers: {
                    'Accept': 'application/vnd.github.v3.text-match+json'
                  }
                });

              case 3:
                _ref3 = _context2.sent;
                total_count = _ref3.data.total_count;
                return _context2.abrupt('return', total_count);

              case 6:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function fetchReactionCount() {
        return _ref2.apply(this, arguments);
      }

      return fetchReactionCount;
    }()
  }, {
    key: 'fetchViewersReaction',
    value: function () {
      var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
        var _props3, client_id, client_secret, owner, repo, issue, _ref5, _ref5$data$items, item, _ref6, reaction;

        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _props3 = this.props, client_id = _props3.client_id, client_secret = _props3.client_secret, owner = _props3.owner, repo = _props3.repo, issue = _props3.issue;
                _context3.t0 = _axios2.default;
                _context3.t1 = client_id;
                _context3.t2 = client_secret;
                _context3.t3 = 'repo:' + owner + '/' + repo + ' commenter:';
                _context3.next = 7;
                return _store2.default.get('username');

              case 7:
                _context3.t4 = _context3.sent;
                _context3.t5 = _context3.t3 + _context3.t4;
                _context3.t6 = _context3.t5 + ' ';
                _context3.t7 = this.key;
                _context3.t8 = _context3.t6 + _context3.t7;
                _context3.t9 = _context3.t8 + ' in:comments';
                _context3.t10 = Date.now();
                _context3.t11 = {
                  client_id: _context3.t1,
                  client_secret: _context3.t2,
                  q: _context3.t9,
                  t: _context3.t10
                };
                _context3.t12 = {
                  'Accept': 'application/vnd.github.v3.text-match+json'
                };
                _context3.t13 = {
                  url: 'https://api.github.com/search/issues',
                  method: 'get',
                  params: _context3.t11,
                  headers: _context3.t12
                };
                _context3.next = 19;
                return (0, _context3.t0)(_context3.t13);

              case 19:
                _ref5 = _context3.sent;
                _ref5$data$items = _slicedToArray(_ref5.data.items, 1);
                item = _ref5$data$items[0];

                if (item) {
                  _context3.next = 24;
                  break;
                }

                return _context3.abrupt('return', null);

              case 24:
                _context3.next = 26;
                return (0, _axios2.default)({
                  url: item.text_matches[0].object_url,
                  method: 'get',
                  params: {
                    client_id: client_id,
                    client_secret: client_secret,
                    t: Date.now()
                  }
                });

              case 26:
                _ref6 = _context3.sent;
                reaction = _ref6.data;
                return _context3.abrupt('return', reaction);

              case 29:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function fetchViewersReaction() {
        return _ref4.apply(this, arguments);
      }

      return fetchViewersReaction;
    }()
  }, {
    key: 'onReact',
    value: function () {
      var _ref7 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
        var _state, reaction, busy, count, _props4, issue, id, owner, repo, client_id, client_secret, _ref8, _reaction;

        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _state = this.state, reaction = _state.reaction, busy = _state.busy, count = _state.count;
                _props4 = this.props, issue = _props4.issue, id = _props4.id, owner = _props4.owner, repo = _props4.repo, client_id = _props4.client_id, client_secret = _props4.client_secret;

                if (!busy) {
                  _context4.next = 4;
                  break;
                }

                return _context4.abrupt('return');

              case 4:

                this.setState({ error: null, busy: true });

                _context4.prev = 5;
                _context4.next = 8;
                return _store2.default.get('access_token');

              case 8:
                if (_context4.sent) {
                  _context4.next = 11;
                  break;
                }

                _GithubLogin2.default.login();
                return _context4.abrupt('return');

              case 11:
                if (reaction) {
                  _context4.next = 28;
                  break;
                }

                _context4.t0 = _axios2.default;
                _context4.t1 = 'https://api.github.com/repos/' + owner + '/' + repo + '/issues/' + issue + '/comments';
                _context4.next = 16;
                return _store2.default.get('access_token');

              case 16:
                _context4.t2 = _context4.sent;
                _context4.t3 = 'token ' + _context4.t2;
                _context4.t4 = {
                  'Authorization': _context4.t3
                };
                _context4.t5 = {
                  body: this.key
                };
                _context4.t6 = {
                  url: _context4.t1,
                  method: 'post',
                  headers: _context4.t4,
                  data: _context4.t5
                };
                _context4.next = 23;
                return (0, _context4.t0)(_context4.t6);

              case 23:
                _ref8 = _context4.sent;
                _reaction = _ref8.data;

                this.setState({
                  reaction: _reaction,
                  count: count + 1
                });
                _context4.next = 39;
                break;

              case 28:
                _context4.t7 = _axios2.default;
                _context4.t8 = 'https://api.github.com/repos/' + owner + '/' + repo + '/issues/comments/' + reaction.id;
                _context4.next = 32;
                return _store2.default.get('access_token');

              case 32:
                _context4.t9 = _context4.sent;
                _context4.t10 = 'token ' + _context4.t9;
                _context4.t11 = {
                  'Authorization': _context4.t10
                };
                _context4.t12 = {
                  url: _context4.t8,
                  method: 'delete',
                  headers: _context4.t11
                };
                _context4.next = 38;
                return (0, _context4.t7)(_context4.t12);

              case 38:
                this.setState({
                  reaction: null,
                  count: count - 1
                });

              case 39:
                _context4.next = 44;
                break;

              case 41:
                _context4.prev = 41;
                _context4.t13 = _context4['catch'](5);

                if (_context4.t13.response && _context4.t13.response.status === 401) {
                  _GithubLogin2.default.login();
                } else {
                  this.setState({ error: _context4.t13 });
                }

              case 44:

                this.setState({ busy: false });

              case 45:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this, [[5, 41]]);
      }));

      function onReact() {
        return _ref7.apply(this, arguments);
      }

      return onReact;
    }()
  }, {
    key: 'render',
    value: function render() {
      var _props5 = this.props,
          _props5$renderer = _props5.renderer,
          Renderer = _props5$renderer === undefined ? _renderer2.default : _props5$renderer,
          issue = _props5.issue,
          id = _props5.id,
          owner = _props5.owner,
          repo = _props5.repo,
          client_id = _props5.client_id,
          client_secret = _props5.client_secret,
          props = _objectWithoutProperties(_props5, ['renderer', 'issue', 'id', 'owner', 'repo', 'client_id', 'client_secret']);

      var busy = this.state.busy;

      if (!this.id) return false;
      return _react2.default.createElement(Renderer, _extends({}, props, this.state, {
        onClick: busy ? function () {} : this.onReact
      }));
    }
  }, {
    key: 'id',
    get: function get() {
      return this.props.id && this.props.id.replace(/[^\w]/g, '_');
    }
  }, {
    key: 'key',
    get: function get() {
      var issue = this.props.issue;

      return '*reaction_for_' + issue + '_' + this.id + '*';
    }
  }]);

  return Reaction;
}(_react.Component);

exports.default = Reaction;